/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_GCTB                                                     */
/* Tabela : GRUPOCTBL                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_GCTB' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_GCTB
GO

CREATE TRIGGER DTULTATU_GCTB
ON GRUPOCTBL
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'GRUPOCTBL', null, 'CDGRUPOCTBL='+ CDGRUPOCTBL+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE GRUPOCTBL
      SET DTULTATUGCTB = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(GRUPOCTBL.CDGRUPOCTBL,0)  = ISNULL(INSERTED.CDGRUPOCTBL,0))  AND
            (ISNULL(GRUPOCTBL.NMGRUPOCTBL,0)  = ISNULL(INSERTED.NMGRUPOCTBL,0))  AND
            (ISNULL(GRUPOCTBL.CDCTBLDEPREC,0) = ISNULL(INSERTED.CDCTBLDEPREC,0)) AND
            (ISNULL(GRUPOCTBL.CDCTBLDESPDP,0) = ISNULL(INSERTED.CDCTBLDESPDP,0)) AND
            (ISNULL(GRUPOCTBL.CDCTBLCORREC,0) = ISNULL(INSERTED.CDCTBLCORREC,0)) AND
            (ISNULL(GRUPOCTBL.CDCTBLBEM,0)    = ISNULL(INSERTED.CDCTBLBEM,0))    AND
            (ISNULL(GRUPOCTBL.VRPEDEPRANO,0)  = ISNULL(INSERTED.VRPEDEPRANO,0));
   END;
END;
GO

