function TimelineController($scope, ScreenService) {
	var widget = $scope.widget;

	function processDates() {
		var dateFormat = $scope.widget.dateFormat || "L";
		var displayDateFormat = $scope.widget.displayDateFormat || dateFormat;
		var timeFormat = $scope.widget.timeFormat || "LT";

		widget.dataSource.data.sort(function(a, b) {
			return moment(b[widget.createdAtField], dateFormat)._d - moment(a[widget.createdAtField], dateFormat)._d;
		});

		var today = moment();
		var todayStr = today.format(displayDateFormat);
		var yesterdayStr = today.subtract(1, 'day').format(displayDateFormat);
		$scope.widget.dataSource.data.forEach(function(item) {
			var mDate = moment(item[widget.createdAtField], dateFormat + ' ' + timeFormat);
			var day = mDate.format(displayDateFormat);
			if (day.slice(0,10) == todayStr) {
				item.dateStr = ScreenService.i18n('Today');
				var minutes = moment().get('minute');
				var hours = minutes / 60;
				if (hours < 1) {
					item.timeStr = Math.floor(minutes) + ' ' + ScreenService.i18n('minute(s) before');
				} else {
					item.timeStr = Math.floor(hours) + ' ' + ScreenService.i18n('hour(s) before');
				}
			} else if (day.slice(0,10) == yesterdayStr) {
				item.dateStr = ScreenService.i18n('Yesterday');
				item.timeStr = mDate.format(timeFormat);
			} else {
				item.dateStr = mDate.format('ddd, ' + displayDateFormat);
				item.timeStr = mDate.format(timeFormat);
			}
		});
	}
	processDates();

	$scope.$watchCollection('widget.dataSource.data', function() {
		processDates();
	});

	$scope.toggle = function(item) {
		if(this.onTimelineIconClick){
			this.onTimelineIconClick();
		}
		item.closed = !item.closed;
	}.bind(widget);
}